#ifndef KSLD_CLIENT_PROTOCOL_H
#define KSLD_CLIENT_PROTOCOL_H

#ifdef  __cplusplus
extern "C" {
#endif

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

struct wl_client;
struct wl_resource;

struct org_kde_ksld;

extern const struct wl_interface org_kde_ksld_interface;

struct org_kde_ksld_listener {
	/**
	 * osdProgress - (none)
	 * @icon: (none)
	 * @percent: (none)
	 * @text: (none)
	 * @since: 2
	 */
	void (*osdProgress)(void *data,
			    struct org_kde_ksld *org_kde_ksld,
			    const char *icon,
			    int32_t percent,
			    const char *text);
	/**
	 * osdText - (none)
	 * @icon: (none)
	 * @text: (none)
	 * @since: 2
	 */
	void (*osdText)(void *data,
			struct org_kde_ksld *org_kde_ksld,
			const char *icon,
			const char *text);
	/**
	 * canSuspendSystem - (none)
	 * @enabled: (none)
	 * @since: 3
	 */
	void (*canSuspendSystem)(void *data,
				 struct org_kde_ksld *org_kde_ksld,
				 uint32_t enabled);
	/**
	 * canHibernateSystem - (none)
	 * @enabled: (none)
	 * @since: 3
	 */
	void (*canHibernateSystem)(void *data,
				   struct org_kde_ksld *org_kde_ksld,
				   uint32_t enabled);
};

static inline int
org_kde_ksld_add_listener(struct org_kde_ksld *org_kde_ksld,
			  const struct org_kde_ksld_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) org_kde_ksld,
				     (void (**)(void)) listener, data);
}

#define ORG_KDE_KSLD_X11WINDOW	0
#define ORG_KDE_KSLD_SUSPENDSYSTEM	1
#define ORG_KDE_KSLD_HIBERNATESYSTEM	2

#define ORG_KDE_KSLD_X11WINDOW_SINCE_VERSION	1
#define ORG_KDE_KSLD_SUSPENDSYSTEM_SINCE_VERSION	3
#define ORG_KDE_KSLD_HIBERNATESYSTEM_SINCE_VERSION	3

static inline void
org_kde_ksld_set_user_data(struct org_kde_ksld *org_kde_ksld, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) org_kde_ksld, user_data);
}

static inline void *
org_kde_ksld_get_user_data(struct org_kde_ksld *org_kde_ksld)
{
	return wl_proxy_get_user_data((struct wl_proxy *) org_kde_ksld);
}

static inline uint32_t
org_kde_ksld_get_version(struct org_kde_ksld *org_kde_ksld)
{
	return wl_proxy_get_version((struct wl_proxy *) org_kde_ksld);
}

static inline void
org_kde_ksld_destroy(struct org_kde_ksld *org_kde_ksld)
{
	wl_proxy_destroy((struct wl_proxy *) org_kde_ksld);
}

static inline void
org_kde_ksld_x11window(struct org_kde_ksld *org_kde_ksld, uint32_t id)
{
	wl_proxy_marshal((struct wl_proxy *) org_kde_ksld,
			 ORG_KDE_KSLD_X11WINDOW, id);
}

static inline void
org_kde_ksld_suspendSystem(struct org_kde_ksld *org_kde_ksld)
{
	wl_proxy_marshal((struct wl_proxy *) org_kde_ksld,
			 ORG_KDE_KSLD_SUSPENDSYSTEM);
}

static inline void
org_kde_ksld_hibernateSystem(struct org_kde_ksld *org_kde_ksld)
{
	wl_proxy_marshal((struct wl_proxy *) org_kde_ksld,
			 ORG_KDE_KSLD_HIBERNATESYSTEM);
}

#ifdef  __cplusplus
}
#endif

#endif
